# Temp Switches

import sys
from _globals import AvailableDCs, ReallyAvailableDCs, AvailableUnits, num_of_dcs, cp
import Triggers
from Classes.class_player import Player
from Classes.class_tempswitch import TempSwitch
import copy

dc_max = (2**31)-1

#Note:  the used_by entry in the __init__ function is only used 
#       when you are using DC's for "Current Player", but you know
#       that this DC will only appear for certain players using it.
#
#       e.g. lets say you want a DC that keeps track of a players level,
#       and lets say only force 1 containing players 1 to 5 will need this DC.
#       Then you can say player_level = DC("Current Player", force_1),
#       where force_1 is a list containing all the players in force 1.
#
#       This lets TriGen know to only use up players 1-5 of whatever unit the DC list is pulling from.
#       i.e. then later if you have another DC, it would go to player 6 of that same unit.
#       If you just leave the used_by entry blank, then the three dc's players 6-8 of that unit would be
#       though to be used up, even though you can still use them in your map.
class DC:
    objs = []
    def __init__(self, player="Any", max=dc_max, used_by = None):
        global AvailableUnits, AvailableDCs, ReallyAvailableDCs, num_of_dcs
        num_of_dcs += 1
        self.used_by = used_by
        if isinstance(player, Player):
            self.player = player.name
            player = player.name
        if player == "Any":
            for idx, slot in enumerate(ReallyAvailableDCs):
                for idx2, player in enumerate(slot):
                    if player:
                        self.player = idx2+1
                        self.unitidx = idx
                        self.unit = AvailableUnits[idx]
                        AvailableDCs[idx][idx2] = False
                        ReallyAvailableDCs[idx][idx2] = False
                        break
                else:
                    continue
                break
        elif player == "Current Player" and used_by == None:
            for idx, slot in enumerate(ReallyAvailableDCs):
                open = True
                for idx2, player in enumerate(slot):
                    if player == False:
                        open = False
                        break
                if open == True:
                    self.player = "Current Player"
                    self.unitidx = idx
                    self.unit = AvailableUnits[idx]
                    for i in range(len(AvailableDCs[idx])):
                        AvailableDCs[idx][i] = False
                        ReallyAvailableDCs[idx][i] = False
                    break
        elif player == "Current Player":
            self.used_by = copy.deepcopy(used_by)
            for idx, player in enumerate(self.used_by):
                if isinstance(player, Player):
                    if player.name == "Player 1":
                        self.used_by[idx] = 1
                    elif player.name == "Player 2":
                        self.used_by[idx] = 2
                    elif player.name == "Player 3":
                        self.used_by[idx] = 3
                    elif player.name == "Player 4":
                        self.used_by[idx] = 4
                    elif player.name == "Player 5":
                        self.used_by[idx] = 5
                    elif player.name == "Player 6":
                        self.used_by[idx] = 6
                    elif player.name == "Player 7":
                        self.used_by[idx] = 7
                    elif player.name == "Player 8":
                        self.used_by[idx] = 8
                    else:
                        self.used_by[idx] = player.name
                        
            for idx, slot in enumerate(ReallyAvailableDCs):
                open = True
                for idx2, player in enumerate(slot):
                    if player == False and (idx2+1) in self.used_by:
                        open = False
                        break
                if open == True:
                    self.player = "Current Player"
                    self.unitidx = idx
                    self.unit = AvailableUnits[idx]
                    for i in range(len(ReallyAvailableDCs[idx])):
                        if (i+1) in self.used_by:
                            AvailableDCs[idx][i] = False
                            ReallyAvailableDCs[idx][i] = False
                    break
        else:
            if isinstance(player, str):
                if player == "Player 1":
                    self.player = 1
                elif player == "Player 2":
                    self.player = 2
                elif player == "Player 3":
                    self.player = 3
                elif player == "Player 4":
                    self.player = 4
                elif player == "Player 5":
                    self.player = 5
                elif player == "Player 6":
                    self.player = 6
                elif player == "Player 7":
                    self.player = 7
                elif player == "Player 8":
                    self.player = 8
                else:
                    self.player = player
                    self.unit = "Terran Marine"
                    
            elif isinstance(player, int):
                self.player = player
            
            if isinstance(self.player, int):
                for idx, slot in enumerate(AvailableDCs):
                    if slot[self.player-1]:
                        self.unit = AvailableUnits[idx]
                        AvailableDCs[idx][self.player-1] = False
                        ReallyAvailableDCs[idx][self.player-1] = False
                        break
        if max == "max":
            max = dc_max
        self.max = max
        
        self.states = []
        DC.objs.append(self)
    # Conditions
    def exactly(self, var, player = None):
        if player == None:
            return Triggers.Conditions.deaths(self.player, self.unit, "Exactly", var)
        else:
            return Triggers.Conditions.deaths(player, self.unit, "Exactly", var)
            
    
    def at_least(self, var, player = None):
        if player == None:
            return Triggers.Conditions.deaths(self.player, self.unit, "At least", var)
        else:
            return Triggers.Conditions.deaths(player, self.unit, "At least", var)
    
    def at_most(self, var, player= None):
        if player == None:
            return Triggers.Conditions.deaths(self.player, self.unit, "At most", var)
        else:
            return Triggers.Conditions.deaths(player, self.unit, "At most", var)
    
    def between(self, var1, var2, player= None):
        if player == None:
            return [Triggers.Conditions.deaths(self.player, self.unit, "At least", var1), Triggers.Conditions.deaths(self.player, self.unit, "At most", var2)]
        else:
            return [Triggers.Conditions.deaths(player, self.unit, "At least", var1), Triggers.Conditions.deaths(player, self.unit, "At most", var2)]
    
    def __eq__(self, var):
        "overloads == operator, letting you do dc == 7, or dc1 == dc2"
        if isinstance(var, int):
            return Triggers.Conditions.deaths(self.player, self.unit, "Exactly", var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0, var == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
        elif isinstance(var, str):
            if var == "max":
                return Triggers.Conditions.deaths(self.player, self.unit, "Exactly", self.max)
            else:
                for idx, thing in enumerate(self.states):
                    if (thing == var):
                        return Triggers.Conditions.deaths(self.player,self.unit,"Exactly",idx)
    
    def __ge__(self, var):
        "overloads >= operator"
        if isinstance(var, int):
            if var == 0:
                return Triggers.Conditions.always()
            return Triggers.Conditions.deaths(self.player, self.unit, "At least", var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[var == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
        elif isinstance(var, "max"):
            return Triggers.Conditions.deaths(self.player, self.unit, "At least", self.max)
    
    def geq(self,var,player = None):
        if player == None:
            return self >= var
        else:
            if isinstance(var, DC):
                max_power = ((min(self.max,var.max)).bit_length()-1)
                out = []
                temp = TempDC("Any")
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( 
                        C=[var.geq(2**i,player), self>=2**i], 
                        A=[var.sub(2**i,player), self-2**i, temp+(2**i)]
                        ) )
                out.append( Triggers.Trigger.T( C=[var == 0], A=[True] ) )
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var.add(2**i,player), self+2**i]) )
                temp.destroy()
                return out
            else:
                return Triggers.Conditions.deaths(player, self.unit, "At least", var)
    
    def __gt__(self, var):
        "overloads > operator"
        if isinstance(var, int):
            return Triggers.Conditions.deaths(self.player, self.unit, "At least", var+1)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[var == 0, self > 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
            
    def __le__(self, var):
        "overloads <= operator"
        if isinstance(var, int):
            if var == 0:
                return Triggers.Conditions.deaths(self.player, self.unit, "Exactly", 0)
            return Triggers.Conditions.deaths(self.player, self.unit, "At most", var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
        elif isinstance(var, "max"):
            return Triggers.Conditions.deaths(self.player, self.unit, "At most", self.max)
            
    def __lt__(self, var):
        "overloads < operator"
        if isinstance(var, int):
            if var == 0:
                return Triggers.Conditions.never()
            return self <= (var-1)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0, var > 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
        elif isinstance(var, "max"):
            return self <= (self.max-1)
            
    #Actions
    def set_to(self, var, player = None):
        "Sets the DC to its argument.  This of this like an = operator."
        "e.g. dc1.set_to(5), or dc1.set_to(dc2)"
        if isinstance(var, int):
            if player == None:
                player = self.player
            return Triggers.Actions.set_deaths(player,self.unit,"Set to",var)
        elif isinstance(var, DC):
            if player == None:
                if var.max > self.max:
                    print ("You just tried to set a DC past its max value.")
                    self.undefined
            
                max_power = ((var.max).bit_length()-1)
                out = [Triggers.Trigger.T( A=[self.set_to(0)] )]
                temp = TempDC("Any")
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+(2**i)]) )
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
                temp.destroy()
                return out
            else:
                if var.max > self.max:
                    print ("You just tried to set a DC past its max value.")
                    self.undefined
            
                max_power = ((var.max).bit_length()-1)
                out = [Triggers.Trigger.T( A=[self.set_to(0)] )]
                temp = TempDC("Any")
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( C=[var.geq(2**i,player)], 
                        A=[var.sub(2**i,player), temp+2**i, self+(2**i)]) )
                for i in range(max_power, -1, -1):
                    out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var.add(2**i,player)]) )
                temp.destroy()
                return out
                
        elif var == "max":
            return Triggers.Actions.set_deaths(player,self.unit,"Set to",self.max)
        elif isinstance(var, str):
            for idx, thing in enumerate(self.states):
                if (thing == var):
                    return Triggers.Actions.set_deaths(player,self.unit,"Set to",idx)
                
            
    def become(self, var):
        "Sets the DC to its argument.  This of this like an = operator."
        "e.g. dc1.set_to(5), or dc1.set_to(dc2)"
        "This differs from set_to in that, if you were to destroy the argument immediately after, this is twice as efficient"
        "e.g. the two following operations are equivalent:"
        " "
        "1: dc1.set_to(dc2), dc2.set_to(0), dc2.destroy()"
        "2: dc1.become(dc2)"
        " "
        "but the second is twice as efficient as the first."
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player,self.unit,"Set to",var)
        elif isinstance(var, DC):
        
            if var.max > self.max:
                print ("You just tried to set a DC past its max value.")
                self.undefined
                
            max_power = ((var.max).bit_length()-1)
            out = [Triggers.Trigger.T( A=[self.set_to(0)] )]
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self+(2**i)]) )
            return out
            
        
    def __add__(self, var):
        "Overloads the + operator, so you can write things like the following:"
        "dc1 + 2, which is equivalent to saying dc1 = dc1 + 2"
        "dc1 + dc2, which is equivalent to saying dc1 = dc1 + dc2"
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player,self.unit,"Add",var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+(2**i)]) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
            temp.destroy()
            return out
            
    def add(self, var, player = None):
        "Alternative way of calling the + operator."
        if player == None:
            return self + var
        else:
            return Triggers.Actions.set_deaths(player,self.unit,"Add",var)
    def add_del(self, var):
        "Adds the value of the argument to the calling DC, and destroys the argument after."
        "Twice as efficient if you were to manually destroy the argument after."
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player,self.unit,"Add",var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self+(2**i)]) )
            return out
    
    def __sub__(self, var):
        "Overloads the - operator, so you can write things like the following:"
        "dc1 - 2, which is equivalent to saying dc1 = dc1 - 2"
        "dc1 - dc2, which is equivalent to saying dc1 = dc1 - dc2"
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player,self.unit,"Subtract",var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self-(2**i)]) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
            temp.destroy()
            return out
            
    def sub(self, var, player = None):
        "Alternative way of calling the - operator."
        if player == None:
            return self - var
        else:
            return Triggers.Actions.set_deaths(player,self.unit,"Subtract",var)
        
    def sub_del(self, var):
        "Subtracts the value of the argument to the calling DC, and destroys the argument after."
        "Twice as efficient if you were to manually destroy the argument after."
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player,self.unit,"Subtract",var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self-(2**i)]) )
            return out
            
    def __mul__(self, var):
        "Multiplies the value of the argument to the calling DC"
        max_power = (self.max.bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[self>=2**i], A=[self-(2**i), temp+(2**i)]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, self+var*(2**i)]) )
        temp.destroy()
        return out    
            
    def divide(self, var):
        "divides by an power of 2"
        max_power = (self.max.bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[self>=2**i], A=[self-(2**i), temp+(2**i)]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, self+((2**i)//var)]) )
        temp.destroy()
        return out
            
    #More custom functions
    
    #Random -> sets dc to random number between 0 and ONE LESS THAN whatever integer you input
    def random(self, var, num = 31):
        #This is just for trigen itself
        dummy_temp = TempSwitch()
        if (var & (var-1) != 0):
            num_of_temp_switches = num
            temp_switches = []
            out = [self.set_to(0)]
            for i in range(num_of_temp_switches):
                temp_switches.append(TempSwitch())
                out.append(temp_switches[-1].randomize())
                
            for i in range(num_of_temp_switches):
                out.append(Triggers.Trigger.T(   C=[temp_switches[i] == "set"],  A=[self + 2**i] ))
                
            if isinstance(var, int):
                for i in range(((2**num_of_temp_switches)//var).bit_length()-1, -1, -1):
                    out.append(Triggers.Trigger.T(   C=[self >= var*2**i],    A=[self - var*2**i] ))
            else:
                temp_dc = TempDC()
                out.append(Triggers.Trigger.T(   A=[temp_dc.set_to(var)] ))
                for i in range(num_of_temp_switches, -1, -1):
                    out.append(Triggers.Trigger.T(   A=[var * (2**i)] ))
                    out.append(Triggers.Trigger.T(   C=[self >= var],    A=[self - var, var.set_to(temp_dc)] ))
                
                out.append(Triggers.Trigger.T(   A=[temp_dc.set_to(0)] ))
                temp_dc.destroy()
                    
        else:
            num_of_temp_switches = 0
            out=[self.set_to(1)]
                
        for i in range(num_of_temp_switches):
            out.append(temp_switches[i].clear())
            temp_switches[i].destroy()       
        dummy_temp.destroy()  
            
        return out
        
    def minus_x_times_dc(self, num, var):
        "lets you do self - x*dc"
        max_power = ((min(self.max, var.max)).bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self-(num*(2**i))]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
        temp.destroy()
        return out
    def add_x_times_dc(self, num, var):
        "lets you do self - x*dc"
        max_power = ((min(self.max, var.max)).bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+(num*(2**i))]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
        temp.destroy()
        return out
    def add_dc_divided_by(self, var, num):
        "lets you do self + dc//x"
        max_power = ((min(self.max, var.max)).bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+((2**i)//num)]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
        temp.destroy()
        return out
    def sub_dc_divided_by(self, var, num):
        "lets you do self + dc//x"
        max_power = ((min(self.max, var.max)).bit_length()-1)
        out = []
        temp = TempDC("Any")
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self-((2**i)//num)]) )
        for i in range(max_power, -1, -1):
            out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
        temp.destroy()
        return out
    
        
        
            
    @classmethod
    def num(clf):
        global num_of_dcs
        return num_of_dcs
        
    # Strings for deathcounters
    def new_state(self, text):
        self.states.append(text)
        return
    
from Classes.class_tempdc import TempDC


    
    
    
    
    
    
    
    
    
    
    
    