# Location Class

from _globals import *
import Triggers
from Classes.class_dc import DC, dc_max


class Dictionary(DC):
    def __init__(self, list, player="Any", used_by = None):
        DC.__init__(self, player, len(list)-1, used_by)
        self.dict = {}
        for num,thing in enumerate(list):
            self.dict[thing] = num
    
        
    # Conditions
    def __eq__(self, var):
        "overloads == operator, letting you say dictionary == 'thing'"
        if isinstance(var,str):
            return Triggers.Conditions.deaths(self.player, self.unit, "Exactly", self.dict[var])
        else:
            return DC.__eq__(self,var)
        
        
    #Actions
    def set_to(self, var,player = None):
        "Sets the DC to its argument.  This of this like an = operator."
        if player == None:
            player = self.player
        if isinstance(var,str):
            return Triggers.Actions.set_deaths(player,self.unit,"Set to",self.dict[var])
        else:
            return DC.set_to(self,var,player)
        
    def append(self, key):    
        "Adds a keyword into the objects dictionary"
        self.dict[key] = len(self.dict)
        return
        
        
        
        
        
        
        