# Location Class

from _globals import *
import Triggers
from Classes.class_dc import DC
from Classes.class_tempdc import TempDC

class EUD(DC):
    def __init__(self, index, offset, shared = None):
        self.player = "Int:"+str(index)
        self.unit = "Terran Marine"
        
        self.offset = offset
        if offset == 0:
            self.offset_num = 1
        elif offset == 1:
            self.offset_num = 256
        elif offset == 2:
            self.offset_num = 65536
        else:
            self.offset_num = 16777216
            
        self.shared = shared
        
    # Conditions
    
    def __eq__(self, var):
        "overloads == operator, letting you do minerals == 7, or gas == dc2"
        if isinstance(var, int):
            if self.shared == None:
                out = []
                out.append(Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var))
                out.append(Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1))
                return out
            elif max(self.shared) == self.offset_num:
                out = []
                out.append(Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var))
                out.append(Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1))
                return out
            else:
                temp = TempDC("Any")
                out = []
                num = 8*(self.offset+1)
                for i in range(30, num-1, -1):
                    out.append( Triggers.Trigger.T( 
                                    C=[Triggers.Conditions.deaths(self.player, self.unit, "At least", 2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", 2**i), temp+(2**i)] ) )
                out.append( Triggers.Trigger.T( 
                                    C=[ Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var),
                                        Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1) ],
                                    A=[True] ) )
                for i in range(30, num-1, -1):
                     out.append( Triggers.Trigger.T( 
                                    C=[temp>=(2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Add", 2**i), temp-(2**i)] ) )
                temp.destroy()
                return out
                
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0, var == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
    
    def __ge__(self, var):
        "overloads >= operator"
        if isinstance(var, int):
            if var == 0:
                return Triggers.Conditions.always()
            elif self.shared == None:
                return Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var)
            elif self.offset_num == max(self.shared):
                return Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var)
            else:
                temp = TempDC("Any")
                out = []
                num = 8*(self.offset+1)
                for i in range(30, num-1, -1):
                    out.append( Triggers.Trigger.T( 
                                    C=[Triggers.Conditions.deaths(self.player, self.unit, "At least", 2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", 2**i), temp+(2**i)] ) )
                out.append( Triggers.Trigger.T( 
                                    C=[ Triggers.Conditions.deaths(self.player, self.unit, "At least", self.offset_num*var) ],
                                    A=[True] ) )
                for i in range(30, num-1, -1):
                     out.append( Triggers.Trigger.T( 
                                    C=[temp>=(2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Add", 2**i), temp-(2**i)] ) )
                temp.destroy()
                return out
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[var == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
    
    def __gt__(self, var):
        "overloads > operator"
        if isinstance(var, int):
            return self >= var+1
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[var == 0, self > 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
            
    def __le__(self, var):
        "overloads <= operator"
        if isinstance(var, int):
            if var == 0:
                return self == 0
            if var == 0:
                return self == 0
            elif self.shared == None:
                return Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1)
            elif self.offset_num == max(self.shared):
                return Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1)
            else:
                temp = TempDC("Any")
                out = []
                num = 8*(self.offset+1)
                for i in range(30, num-1, -1):
                    out.append( Triggers.Trigger.T( 
                                    C=[Triggers.Conditions.deaths(self.player, self.unit, "At least", 2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", 2**i), temp+(2**i)] ) )
                out.append( Triggers.Trigger.T( 
                                    C=[ Triggers.Conditions.deaths(self.player, self.unit, "At most", (self.offset_num*var)+self.offset_num-1) ],
                                    A=[True] ) )
                for i in range(30, num-1, -1):
                     out.append( Triggers.Trigger.T( 
                                    C=[temp>=(2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Add", 2**i), temp-(2**i)] ) )
                temp.destroy()
                return out
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
            
    def __lt__(self, var):
        "overloads < operator"
        if isinstance(var, int):
            if var == 0:
                return Triggers.Conditions.never()
            return self <= (var-1)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i, self>=2**i], A=[var-(2**i), self-(2**i), temp+(2**i)]) )
            out.append( Triggers.Trigger.T( C=[self == 0, var > 0], A=[True] ) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i, self+2**i]) )
            temp.destroy()
            return out
        
    #Actions
    def set_to(self, var):
        "Sets the DC to its argument.  This of this like an = operator."
        "e.g. dc1.set_to(5), or dc1.set_to(dc2)"
        if isinstance(var, int):
            if self.shared == None:
                return Triggers.Actions.set_deaths(self.player, self.unit, "Set to", self.offset_num*var)
            else:
                out = []
                temp = TempDC()
                if self.offset_num < max(self.shared):
                    num1 = 8*(self.offset+1)
                    for i in range(30, num1-1, -1):
                        out.append( Triggers.Trigger.T( 
                                        C=[Triggers.Conditions.deaths(self.player, self.unit, "At least", 2**i)], 
                                        A=[Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", 2**i), temp+(2**i)] ) )
                num2 = 8*(self.offset)
                for i in range(30,num2-1,-1):
                     out.append( Triggers.Trigger.T( 
                                    C=[Triggers.Conditions.deaths(self.player, self.unit, "At least", 2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", 2**i)] ) )
                out.append( Triggers.Actions.set_deaths(self.player, self.unit, "Add", self.offset_num*var) )
                if self.offset_num < max(self.shared):
                    for i in range(30, num1-1, -1):
                     out.append( Triggers.Trigger.T( 
                                    C=[temp>=(2**i)], 
                                    A=[Triggers.Actions.set_deaths(self.player, self.unit, "Add", 2**i), temp-(2**i)] ) )
                temp.destroy()
                return out
        elif isinstance(var, DC):
        
            if var.max > self.max:
                print ("You just tried to set a DC past its max value.")
                sys.exit()
        
            max_power = ((var.max).bit_length()-1)
            out = [Triggers.Trigger.T( A=[self.set_to(0)] )]
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+(2**i)]) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
            temp.destroy()
            return out
            
    def become(self, var):
        "Sets the DC to its argument.  This of this like an = operator."
        "e.g. dc1.set_to(5), or dc1.set_to(dc2)"
        "This differs from set_to in that, if you were to destroy the argument immediately after, this is twice as efficient"
        "e.g. the two following operations are equivalent:"
        " "
        "1: dc1.set_to(dc2), dc2.set_to(0), dc2.destroy()"
        "2: dc1.become(dc2)"
        " "
        "but the second is twice as efficient as the first."
        if isinstance(var, int):
            return self.set_to(var)
        elif isinstance(var, DC):
        
            if var.max > self.max:
                print ("You just tried to set a DC past its max value.")
                sys.exit()
                
            max_power = ((var.max).bit_length()-1)
            out = [Triggers.Trigger.T( A=[self.set_to(0)] )]
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self+(2**i)]) )
            return out
            
        
    def __add__(self, var):
        "Overloads the + operator, so you can write things like the following:"
        "dc1 + 2, which is equivalent to saying dc1 = dc1 + 2"
        "dc1 + dc2, which is equivalent to saying dc1 = dc1 + dc2"
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player, self.unit, "Add", self.offset_num*var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self+(2**i)]) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
            temp.destroy()
            return out
            
    def add(self, var):
        "Alternative way of calling the + operator."
        return self + var
        
    def add_del(self, var):
        "Adds the value of the argument to the calling DC, and destroys the argument after."
        "Twice as efficient if you were to manually destroy the argument after."
        if isinstance(var, int):
            return self.add(var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self+(2**i)]) )
            return out
    
    def __sub__(self, var):
        "Overloads the - operator, so you can write things like the following:"
        "dc1 - 2, which is equivalent to saying dc1 = dc1 - 2"
        "dc1 - dc2, which is equivalent to saying dc1 = dc1 - dc2"
        if isinstance(var, int):
            return Triggers.Actions.set_deaths(self.player, self.unit, "Subtract", self.offset_num*var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            temp = TempDC("Any")
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), temp+(2**i), self-(2**i)]) )
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[temp>=2**i], A=[temp-2**i, var+2**i]) )
            temp.destroy()
            return out
            
    def sub(self, var):
        "Alternative way of calling the - operator."
        return self - var
        
    def sub_del(self, var):
        "Subtracts the value of the argument to the calling DC, and destroys the argument after."
        "Twice as efficient if you were to manually destroy the argument after."
        if isinstance(var, int):
            return self.sub(var)
        elif isinstance(var, DC):
            max_power = ((min(self.max, var.max)).bit_length()-1)
            out = []
            for i in range(max_power, -1, -1):
                out.append( Triggers.Trigger.T( C=[var>=2**i], A=[var-(2**i), self-(2**i)]) )
            return out
    
    
      
        
        
        
        
        
        
        
        
        
        
        
        
        