# Location Class

from _globals import unit_scores
import Triggers
from Classes.class_unit import Unit

class Player:
    def __init__(self, name):
        self.name = name
        
    # Conditions
    
    def accumulate(self, qmod = "At least",num = 1,resource = "ore and gas"):
        return Triggers.Conditions.accumulate(self.name, qmod, num, resource)
        
    def score(self, type, qmod = "At least", num = 1):
        return Triggers.Conditions.score(self.name, type, qmod = "At least", num = 1)
        
    def kill(self, unit, qmod = "Exactly", num = 1):
        global unit_scores
        if isinstance(unit, Unit):
            unit = unit.name
        return Triggers.Conditions.score(self.name, "Kills", qmod, num*unit_scores[unit])
        
    # Actions
    
    def set_resources(self, mod, num, type):
        return Triggers.Actions.set_resources(self.name, mod, num, type)
        
    def set_score(self, type, mod = "Set to", num = 0):
        return Triggers.Actions.set_score(self.name, mod, num, type)
        
    def kill_sub(self, unit, num = 1):
        global unit_scores
        if isinstance(unit, Unit):
            unit = unit.name
        return Triggers.Actions.set_score(self.name, "Subtract", num*unit_scores[unit], "Kills")
        
    def set_to_ally(self):
        return Triggers.Actions.set_alliance_status(self.name, "Ally")
        
    def set_to_enemy(self):
        return Triggers.Actions.set_alliance_status(self.name, "Enemy")    
        
    def set_to_allied_victory(self):
        return Triggers.Actions.set_alliance_status(self.name, "Allied Victory")

    def get_vision(self):
        return Triggers.Actions.set_vision(self.name, "enabled")
        
    def lose_vision(self):
        return Triggers.Actions.set_vision(self.name, "disabled")
        
        
        





        