# Defines all of the actions.
    
from _globals import all_strings
from Classes.class_location import Location
from Classes.class_unit import Unit
from Classes.class_player import Player


def center_view(location):
    if isinstance(location, Location):
        location = location.name
    return "Center View(\""+location+"\");"
    
def comment(text):
    return "Comment(\""+text+"\");"
    
def create_unit(player, unit, num, location, property = None):
    if property == "Invincible":
        property = 0

    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(create_unit(thing, unit, num, location, property))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    if property == None:
        text = "Create Unit(\""
    else:
        text = "Create Unit with Properties(\""
        
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
    text += "\""+unit+"\", "+str(num)+", \""+location
    
    if property == None:
        text += "\");"
    else:
        text += "\", "+str(property)+");"
    return text
    
def create_unit_with_properties(player, unit, num, location, property):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(create_unit_with_properties(thing, unit, num, location, property))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    return create_unit(player, unit, num, location, property)
    
def defeat():
    return "Defeat();"
#defeat = defeat()

def display_text(text, always_display = "Always Display"):
    global all_strings
    all_strings.append(text)
    return "Display Text Message("+always_display+", \""+text+"\");"
    
def draw():
    return "Draw();"
#draw = draw()

def give_unit(old_player, new_player, unit = "All", num = "All", location = "Anywhere"):
    if isinstance(old_player, list):
        out = []
        for thing in old_player:
            out.append(give_unit(thing, new_player, unit, num, location))
        return out
        
        
        
    if isinstance(old_player, Player):
        old_player = old_player.name
    if isinstance(new_player, Player):
        new_player = new_player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Give Units to Player(\""
    
    if isinstance(old_player, int):
        text += "Player "+str(old_player)+"\", \""
    elif isinstance(old_player, str):
        text += old_player+"\", \""
    
    if isinstance(new_player, int):
        text += "Player "+str(new_player)+"\", "
    elif isinstance(new_player, str):
        text += new_player+"\", "
        
    text += "\""+unit+"\", "+str(num)+", \""+location+"\");"
    return text

def kill_unit(player, unit = "All"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(kill_unit(thing, unit))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    text = "Kill Unit(\""
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
    text += "\""+unit+"\");"
    return text
    
def kill_unit_at_location(player, unit = "All", num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(kill_unit_at_location(thing, unit, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Kill Unit At Location(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(num)+", \""+location+"\");"
    return text

def leaderboard_control_at_location(text, unit, location):
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    return "Leader Board Control At Location(\""+text+"\", \""+unit+"\", \""+location+"\");"

def leaderboard_control(text, unit):
    if isinstance(unit, Unit):
        unit = unit.name
    return "Leader Board Control(\""+text+"\", \""+unit+"\");"
    
def leaderboard_greed(num):
    return "Leaderboard Greed("+str(num)+");"
    
def leaderboard_kills(text, unit):
    if isinstance(unit, Unit):
        unit = unit.name
    return "Leader Board Kills(\""+text+"\", \""+unit+"\");"
    
def leaderboard_points(text, type):
    return "Leader Board Points(\""+text+"\", "+type+");"
    
def leaderboard_resources(text, type):
    return "Leader Board Resources(\""+text+"\", "+type+");"
    
def leaderboard_computer_players(action):
    return "Leaderboard Computer Players("+action+");"
    
def leaderboard_goal_control_at_location(text, unit, num, location):
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    return "Leaderboard Goal Control At Location(\""+text+"\", \""+unit+"\", "+str(num)+", \""+location+"\");"
    
def leaderboard_goal_control(text, unit, num):
    if isinstance(unit, Unit):
        unit = unit.name
    return "Leaderboard Goal Control(\""+text+"\", \""+unit+"\", "+str(num)+");"
    
def leaderboard_goal_kills(text, unit, num):
    if isinstance(unit, Unit):
        unit = unit.name
    return "Leaderboard Goal Kills(\""+text+"\", \""+unit+"\", "+str(num)+");"
    
def leaderboard_goal_points(text, type, num):
    return "Leaderboard Goal Points(\""+text+"\", "+type+", "+str(num)+");"
    
def leaderboard_goal_resources(text, num, type):
    return "Leaderboard Goal Points(\""+text+"\", "+str(num)+", "+type+");"
    
def minimap_ping(location):
    return "Minimap Ping(\""+location+"\");"
    
def modify_unit_energy(player, unit, amount, num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(modify_unit_energy(thing, unit, amount, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Modify Unit Energy(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(amount)+", "+str(num)+", \""+location+"\");"
    return text
    
def modify_unit_hanger_count(player, unit, amount, num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(modify_unit_hanger_count(thing, unit, amount, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Modify Unit Hanger Count(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(amount)+", "+str(num)+", \""+location+"\");"
    return text

def modify_unit_hit_points(player, unit, amount, num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(modify_unit_hit_points(thing, unit, amount, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Modify Unit Hit Points(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(amount)+", "+str(num)+", \""+location+"\");"
    return text
    
def modify_unit_resource_amount(player, amount, num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(modify_unit_resource_amount(thing, amount, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(location, Location):
        location = location.name
    text = "Modify Unit Resource Amount(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += str(amount)+", "+str(num)+", \""+location+"\");"
    return text
    
def modify_unit_shield_points(player, unit, amount, num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(modify_unit_shield_points(thing, unit, amount, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Modify Unit Shield Points(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(amount)+", "+str(num)+", \""+location+"\");"
    return text
    
def move_location(player, unit, to_location, moving_location):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(move_location(thing, unit, to_location, moving_location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(to_location, Location):
        to_location = to_location.name
    if isinstance(moving_location, Location):
        moving_location = moving_location.name
    text = "Move Location(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", \""+to_location+"\", \""+moving_location+"\");"
    return text
   
def move_unit(player, unit, num, from_location, to_location):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(move_unit(thing, unit, num, from_location, to_location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(to_location, Location):
        to_location = to_location.name
    if isinstance(from_location, Location):
        from_location = from_location.name
    text = "Move Unit(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(num)+", \""+from_location+"\", \""+to_location+"\");"
    return text
    
def mute_unit_speech():
    return "Mute Unit Speech();"
#mute_unit_speech = mute_unit_speech()
   
def order(player, unit, from_location, to_location, order):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(order(thing, unit, from_location, to_location, order))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(to_location, Location):
        to_location = to_location.name
    if isinstance(from_location, Location):
        from_location = from_location.name
    text = "Order(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", \""+from_location+"\", \""+to_location+"\", "+order+");"
    return text
    
def pause_game():
    return "Pause Game();"
#pause_game = pause_game()

def pause_timer():
    return "Pause Timer();"
#pause_timer = pause_timer()

def play_wav(name, length):
    text = "Play WAV(\""
    text+= name
    text+= "\", "
    text+= str(length)
    text+= ");"
    return text
    
def preserve_trigger():
    return "Preserve Trigger();"
#preserve_trigger = preserve_trigger()

def remove_unit(player, unit = "All"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(remove_unit(thing, unit))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    text = "Remove Unit(\""
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
    text += "\""+unit+"\");"
    return text
    
def remove_unit_at_location(player, unit = "All", num = "All", location = "Anywhere"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(remove_unit_at_location(thing, unit, num, location))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Remove Unit At Location(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+str(num)+", \""+location+"\");"
    return text
   
def run_ai_script(type):
    return "Run AI Script(\""+type+"\");"
    
def run_ai_script_at_location(type, location = "Anywhere"):
    if isinstance(location, Location):
        location = location.name
    return "Run AI Script At Location(\""+type+"\", \""+location+"\");"
    
def set_alliance_status(player, status):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_alliance_status(thing, status))
        return out

    if isinstance(player, Player):
        player = player.name
    text = "Set Alliance Status(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += status+");"
    return text
    
def set_to_ally(player):
    return set_alliance_status(player, "Ally")
    
def set_to_enemy(player):
    return set_alliance_status(player, "Enemy")
    
def set_countdown_timer(qmod, num):
    return "Set Countdown Timer("+qmod+", "+str(num)+");"
    
def set_deaths(player, unit, mod, num):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_deaths(thing, unit, mod, num))
        return out
        
    if isinstance(player, Player):
        player = player.name
    text = "Set Deaths(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", "+mod+", "+str(num)+");"
    return text
    
def set_doodad_state(player, unit = "All", location = "Anywhere", state = "enabled"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_doodad_state(thing, unit, location, state))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Set Doodad State(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", \""+location+"\", "+state+");"
    return text
    
def set_invincibility(player, unit, location, state = "enabled"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_invincibility(thing, unit, location, state))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(unit, Unit):
        unit = unit.name
    if isinstance(location, Location):
        location = location.name
    text = "Set Invincibility(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += "\""+unit+"\", \""+location+"\", "+state+");"
    return text
   
def set_mission_objectives(text):
    return "Set Mission Objectives(\""+text+"\");"
    
def set_next_scenario(text):
    return "Set Next Scenario(\""+text+"\");"
    
def set_resources(player, mod, num, type):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_resources(thing, mod, num, type))
        return out
        
    if isinstance(player, Player):
        player = player.name
    text = "Set Resources(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += mod+", "+str(num)+", "+type+");"
    return text
    
def set_score(player, mod, num, type):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_score(thing, mod, num, type))
        return out
        
    text = "Set Score(\""
    
    if isinstance(player, int):
        text += "Player "+str(player)+"\", "
    elif isinstance(player, str):
        text += player+"\", "
        
    text += mod+", "+str(num)+", "+type+");"
    return text
    
def set_switch(num, state = "Toggle"):
    return "Set Switch(\"Switch"+str(num)+"\", "+state+");"
   
def talking_portrait(unit, length):
    if isinstance(unit, Unit):
        unit = unit.name
    return "Talking Portrair(\""+unit+"\", "+str(length)+");"
    
def unmute_unit_speech():
    return "Unmute Unit Speed();"
#unmute_unit_speech = unmute_unit_speech()

def unpause_game():
    return "Unpause Game();"
#unpause_game = unpause_game()

def unpause_timer():
    return "Unpause Timer();"
#unpause_timer = unpause_timer()

def victory():
    return "Victory();"
#victory = victory()
    
def wait(num = 0):
    return "Wait("+str(num)+");"
    
def clear_text():
    return [display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" "),
            display_text(" ")]
   
def set_vision(player, state = "enabled"):
    if isinstance(player, list):
        out = []
        for thing in player:
            out.append(set_vision(thing, state))
        return out
        
    if isinstance(player, Player):
        player = player.name
    if isinstance(player, str):
            if player == "Player 1":
                player = 1
            elif player == "Player 2":
                player = 2
            elif player == "Player 3":
                player = 3
            elif player == "Player 4":
                player = 4
            elif player == "Player 5":
                player = 5
            elif player == "Player 6":
                player = 6
            elif player == "Player 7":
                player = 7
            elif player == "Player 8":
                player = 8
            elif player == "Player 9":
                player = 9
            elif player == "Player 10":
                player = 10
            elif player == "Player 11":
                player = 11
            elif player == "Player 12":
                player = 12
                
    if (state == "enabled"):
        if player == 1:
            return run_ai_script("+Vi0")
        if player == 2:
            return run_ai_script("+Vi1")
        if player == 3:
            return run_ai_script("+Vi2")
        if player == 4:
            return run_ai_script("+Vi3")
        if player == 5:
            return run_ai_script("+Vi4")
        if player == 6:
            return run_ai_script("+Vi5")
        if player == 7:
            return run_ai_script("+Vi6")
        if player == 8:
            return run_ai_script("+Vi7")
    if (state == "disabled"):
        if player == 1:
            return run_ai_script("-Vi0")
        if player == 2:
            return run_ai_script("-Vi1")
        if player == 3:
            return run_ai_script("-Vi2")
        if player == 4:
            return run_ai_script("-Vi3")
        if player == 5:
            return run_ai_script("-Vi4")
        if player == 6:
            return run_ai_script("-Vi5")
        if player == 7:
            return run_ai_script("-Vi6")
        if player == 8:
            return run_ai_script("-Vi7")


#EUD stuff
def memory_write(address, mod, num):
    if isinstance(address, int):
        address = 4*(address + 1452249)
        return "MemoryAddr("+hex(address)+", "+mod+", "+str(num)+");"
    else:
        return "MemoryAddr("+address+", "+mod+", "+str(num)+");"

def masked_memory_write(address, mod, num, bit_mask):
    if isinstance(bit_mask, int):
        bit_mask_hex = hex(bit_mask)
    else:
        bit_mask_hex = bit_mask
    if isinstance(address, int):
        address = 4*(address + 1452249)
        return "Masked MemoryAddr("+hex(address)+", "+mod+", "+str(num)+", "+bit_mask_hex+");"
    else:
        return "Masked MemoryAddr("+address+", "+mod+", "+str(num)+", "+bit_mask_hex+");"

#This is the address for Hyper Triggers
def hyper_trigger():
    return memory_write('0x006509a0', "Set To", 0)
    
def set_fog_of_war(mod, num):
    return memory_write('0x0051ce98', mod, num)


   
   
   
